# -*- coding: utf-8 -*-
"""
Copyright (c) 2016 Biuro Urządzania Lasu i Geodezji Leśnej

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), 
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, 
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
OTHER DEALINGS IN THE SOFTWARE.
"""


from PyQt5.QtCore import *
from PyQt5.QtGui import *
from qgis.core import *
from qgis.gui import *

from Mapa_PU.kontroler import komunikaty, warstwa
from Mapa_PU.widok.pasek_wiadomosci import PasekWiadomosc
import processing
        
class GenerujPodOddzialy(QObject):
    """Generowanie pododdziałów"""
    def __init__(self,iface,mapa):
        """Constructor"""
        self.iface = iface
        self.mapa = mapa
        super(GenerujPodOddzialy,self).__init__()  # QObject.__init__()
             
    def showGenerujPodOddzialyDialog(self): 
        self.run()  
        
    def listaBezPowt(self,input_list):
        """ Lista unikatowych adresow lesnych  bez powt�rze�.  Na wejsciu jest lista string�w oraz d�ugosc pola od lewej strony. """
        for unqitem in set( [item for item in input_list] ):
            yield unqitem    
    
    def usunRekordyZWarstwy(self):
        komunikaty.informacja(u"Generuj pododdziały", u"Liczba obiektów usuniętych z warstwy POW: " + str(self.pow.kasujWszystkieObiekty()) )
        
    def run(self):
        
        def wykAgregacja():
            """ funkcja pomocnicza uruchamia agregujWarstwe() """
                
            nowe_pola_oddzialy = QgsFields()
            nowe_pola_oddzialy.append( QgsField("ID", QVariant.Int,"Integer",6) )
            nowe_pola_oddzialy.append( QgsField('ADR_BDL', QVariant.String,"String",25) )
            nowe_pola_oddzialy.append( QgsField('L_EWID', QVariant.String,"String",1) )
            
        
            if (self.warstwa_o_podst.agregujWarstwe(self.warstwa_o_podst, self.pow, nazwaPola='ADR_BDL',sufixPola='' ,listaWartosciPola=_lista_adresow_lesnych,nowePola=nowe_pola_oddzialy,pasekWiadomosc = PasekWiadomosc(self.iface,opis = u'Generowanie pododdziałów'))):
                komunikaty.informacja(u"Generuj pododdziały", u"Wygenerowano Pododdziały")
                                
            else: 
                komunikaty.blad(u"Generuj pododdziały", u"Nie udało się tworzenie Pododdziałów" )
        
        if QgsProject.instance().mapLayersByName('O_PODST') and QgsProject.instance().mapLayersByName('POW'):
                        
            self.warstwa_o_podst=self.generujWarstwe(self.mapa.warstwaRejestr('O_PODST'))
            
            
            #self.warstwa_o_podst = self.mapa.warstwaRejestr('O_PODST')
            self.pow = self.mapa.warstwaRejestr('POW')
                        
            #pola=list(self.warstwa_o_podst.fields())
            adr_bdl_bool=any(elem.name()=='ADR_BDL' for elem in list(self.warstwa_o_podst.fields()))

            #if pola[0].name()=='ADR_BDL': #self.warstwa_o_podst.kontrolaObecnosciPola(nazwaPola='ADR_BDL'):
            if adr_bdl_bool:
                lista=[feature['ADR_BDL'] for feature in self.warstwa_o_podst.getFeatures()]
                _lista_adresow_lesnych = list(self.listaBezPowt(lista))
                 
                if _lista_adresow_lesnych :
                       
                    if (self.pow.liczbaFeatureow() > 0):
                         
                        # Kasowanie w warstwie ODDZIAL #               
                        if not komunikaty.pytanie_usun_anuluj(u'Generuj pododdziały',u'Czy usunąć obiekty z warstwy POW ?'):
                            self.usunRekordyZWarstwy()
                            self.wypelnijWarstwe(self.pow,self.warstwa_o_podst)
                            #wykAgregacja()
         
                    else:
                        self.wypelnijWarstwe(self.pow,self.warstwa_o_podst)    
                        #wykAgregacja()                                                   
                else:
                    komunikaty.blad(u"Generuj pododdziały",u"Brak adresów leśnych w warstwie O_PODST !" )   
            else:
                komunikaty.blad(u"Generuj pododdziały",u"Brak Pola ADR_BDL w Warstwie O_PODST !")
        else:
            komunikaty.wiadomoscKrytyczna(self.iface,u"Proszę otworzyć wymagane pliki !",6)
            
            if not QgsProject.instance().mapLayersByName('O_PODST'):
                komunikaty.blad(u"Generuj pododdziały",u"Brak załadowanej warstwy O_PODST  !")
                
            if not QgsProject.instance().mapLayersByName('POW'):
                komunikaty.blad(u"Generuj pododdziały",u"Brak załadowanej warstwy POW !") 
    
    def wypelnijWarstwe(self,wypelniana,dane):
        """Wypełnia warstwe na podstawie innej warstwy"""
        try:
            id=0
            for feature in dane.getFeatures():
                id+=1
                feat=QgsFeature(wypelniana.fields())
                feat.setAttribute('ID',id)
                feat.setAttribute('ADR_BDL',feature['ADR_BDL'])
                feat.setAttribute('L_EWID','T')
                feat.setGeometry(feature.geometry())
                wypelniana.dataProvider().addFeature(feat)
            wypelniana.triggerRepaint()
            komunikaty.informacja(u"Generuj pododdziały", u"Wygenerowano Pododdziały")
        except Exception as e:
            raise e
    #-------------------------------------------------------------------------------
    
    def generujWarstwe(self,warstwa:QgsMapLayer)->QgsVectorLayer:
        try:
            gras=processing.run("grass7:v.dissolve", {'input':warstwa,'column':'ADR_BDL','output':'TEMPORARY_OUTPUT','GRASS_REGION_PARAMETER':None,'GRASS_SNAP_TOLERANCE_PARAMETER':0.01,'GRASS_MIN_AREA_PARAMETER':0.0001,'GRASS_OUTPUT_TYPE_PARAMETER':0,'GRASS_VECTOR_DSCO':'','GRASS_VECTOR_LCO':'','GRASS_VECTOR_EXPORT_NOCAT':False})
            gras_layer=gras['output']
            #Naprawa geometrii
            fixed=processing.run("native:fixgeometries", {'INPUT':gras_layer,'OUTPUT':'TEMPORARY_OUTPUT'})
            #Łaczenie kawałków w multipolygon
            disolve_layer=processing.run("native:dissolve", {'INPUT':fixed['OUTPUT'],'FIELD':['ADR_BDL'],'OUTPUT':'TEMPORARY_OUTPUT'})
            return disolve_layer['OUTPUT']
            
            
            #saga=processing.run("saga:polygondissolvebyattribute", {'POLYGONS':gras_layer,'FIELD_1':'ADR_BDL','FIELD_2':'','FIELD_3':'','BND_KEEP':False,'DISSOLVED':'TEMPORARY_OUTPUT'})
            #saga_layer=saga['DISSOLVED']
            
            
            #layer = QgsVectorLayer(saga_layer, "naprawiona", "ogr")
            #return layer
#             #Naprawa geometrii
#             a=processing.run("native:fixgeometries", {'INPUT':warstwa,'OUTPUT':'TEMPORARY_OUTPUT'})
#             va=a['OUTPUT']
#             #dociąganie punktów
#             b=processing.run("native:snappointstogrid", {'INPUT':va,'HSPACING':1e-05,'VSPACING':1e-05,'ZSPACING':0,'MSPACING':0,'OUTPUT':'TEMPORARY_OUTPUT'})
#             vb=b['OUTPUT']
#             #agregacja
#             collect_layer=processing.run("saga:polygondissolvebyattribute", {'POLYGONS':vb,'FIELD_1':'ADR_BDL','FIELD_2':'','FIELD_3':'','BND_KEEP':False,'DISSOLVED':'TEMPORARY_OUTPUT'})
#             w=collect_layer['DISSOLVED']
#             vlayer = QgsVectorLayer(w, "naprawiona", "ogr")
#             #Ponowna naprawa warstwy wynikowej
#             a=processing.run("native:fixgeometries", {'INPUT':vlayer,'OUTPUT':'TEMPORARY_OUTPUT'})
#             va=a['OUTPUT']
#             #return va
#             #Rozbicie multipolygon na polygon
#             single_parts=processing.run("native:multiparttosingleparts", {'INPUT':va,'OUTPUT':'TEMPORARY_OUTPUT'})
#             sl=single_parts['OUTPUT']
#             #Nałożenie bufora
#             buffer=processing.run("native:buffer", {'INPUT':sl,'DISTANCE':0.00002,'SEGMENTS':5,'END_CAP_STYLE':2,'JOIN_STYLE':1,'MITER_LIMIT':2,'DISSOLVE':False,'OUTPUT':'TEMPORARY_OUTPUT'})
#             bl=buffer['OUTPUT']
#             #Agregacja bufora 
#             disolve=processing.run("native:dissolve", {'INPUT':bl,'FIELD':['ADR_BDL'],'OUTPUT':'TEMPORARY_OUTPUT'})
#             return disolve['OUTPUT']
            #Koniec naprawy warstwy
        except Exception as e:
            raise e
   
    
        
    
    
    
    